#! /usr/bin/python

import re
import os
if __name__ == '__main__':
	conf = open('/etc/pure-ftpd.conf').readlines()
	args = ""
	for line in conf:

		if re.search("[ ]*#+.*",line):
			continue

		if re.search("IPV4Only[\s]+yes",line,re.I):
			args = args + " -4 "

		if re.search("ChrootEveryone[\s]+yes",line,re.I):
			args = args + " -A "

		m = re.search("TrustedGID[\s]+([\d]+)",line,re.I)
		if m != None :
			args =args + " -a " + m.group(1) 

		if re.search("BrokenClientsCompatibility[\s]+yes",line,re.I):
			args = args + " -b "

		m = re.search("MaxClientsNumber\s+(\d+)",line,re.I)
		if m != None :
			args = args + "-c " + m.group(1) 

		if re.search("Daemonize\s+yes",line,re.I):
 			args = args + " -B "

 		m = re.search("MaxClientsPerIP\s+(\d+)",line,re.I)
		if m != None:
			args = args + " -C " + m.group(1)

		if re.search("VerboseLog\s+yes",line,re.I):
			args = args + " -d "

		if re.search("DisplayDotFiles\s+yes",line,re.I):
			args = args + " -D "

		if re.search("AnonymousOnly\s+yes",line,re.I):
			args = args + " -e "

		if re.search("MaxDiskUsage\s+(\d+)",line,re.I):
			args = args + " -k $1 "                        
                        
		if re.search("NoAnonymous\s+yes",line,re.I):
			args =args +  " -E "

		m = re.search("SyslogFacility\s+(\S+)",line,re.I)
		if m !=None:
			args = args + " -f "+m.group(1)

		m = re.search("FortunesFile\s+(\S+)",line,re.I)
		if m !=None:
			args = args + " -F "+m.group(1)

		if re.search("DontResolve\s+yes",line,re.I):
			args = args + " -H "

		m =re.search("MaxIdleTime\s+(\d+)",line,re.I)
		if m !=None:
			args =args + " -I "+m.group(1)

		m =	re.search("LDAPConfigFile\s+(\S+)",line,re.I)
		if m !=None:
			args =args + " -l ldap:"+m.group(1)

		m =	re.search("MySQLConfigFile\s+(\S+)",line,re.I)
		if m !=None:
			args =args + " -l mysql:"+m.group(1)

		m =	re.search("PureDB\s+(\S+)",line,re.I)
		if m !=None:
			args =args + " -l puredb:"+m.group(1)

		m =	re.search("PAMAuthentication\s+yes",line,re.I)
		if m !=None:
			args =args + " -l pam"+m.group(1)

		m =	re.search("UnixAuthentication\s+yes",line,re.I)
		if m !=None:
			args =args + " -l unix"+m.group(1)

		m =	re.search("LimitRecursion\s+(\d+)\s+(\d+)",line,re.I)
		if m !=None :
			args = args + " -L "+m.group(1)+":"+m.group(2)

		if re.search("AnonymousCanCreateDirs\s+yes",line,re.I):
			args = args + " -M "

		m = re.search("MaxLoad\s+(\d+)",line,re.I)
		if m !=None :
			args = args + " -m "+m.group(1)

		if re.search("NATmode\s+yes",line,re.I):
			args = args + " -N "

		if re.search("CallUploadScript\s+yes",line,re.I):
			args = args + " -o "			
			
		m = re.search("PassivePortRange\s+(\d+)\s+(\d+)",line,re.I)
		if m !=None :
			args = args + " -p "+m.group(1)+":"+m.group(2)

		m = re.search("ForcePassiveIP\s+(\S+)",line,re.I)
		if m !=None :
			args = args + " -P " +m.group(1)

		m = re.search("AnonymousRatio\s+(\d+)\s+(\d+)",line,re.I)
		if m !=None :
			args = args + " -q "+m.group(1)+":"+m.group(2)

		m = re.search("UserRatio\s+(\d+)\s+(\d+)",line,re.I)
		if m !=None :
			args = args + " -Q "+m.group(1)+":"+m.group(2)

		if re.search("AntiWarez\s+yes",line,re.I):
			args = args + " -s "

		m = re.search("Bind\s+(\S+)",line,re.I)
		if m !=None :
			args = args + " -S "+m.group(1)

		m = re.search("AnonymousBandwidth\s+([:0-9]+)",line,re.I)
		if m !=None :
			args = args +"-t "+m.group(1)

		m = re.search("UserBandwidth\s+([:0-9]+)",line,re.I)
		if m !=None :
			args =  args +"-T "+m.group(1)

		m = re.search("Quota\s+([:0-9]+)",line,re.I)
		if m !=None :
			args =  args +"-n "+m.group(1)

		m = re.search("Umask\s+(\d+):(\d+)",line,re.I)
		if m !=None :
			args = args +" -U "+m.group(1)+":"+m.group(2)

		m = re.search("MinUID\s+(\d+)",line,re.I)
		if m !=None :
			args = args +" -u "+m.group(1)

		if re.search("AllowUserFXP\s+yes",line,re.I):
			 args = args +  " -w "

		if re.search("AllowAnonymousFXP\s+yes",line,re.I):
			args = args + " -W  "

		if re.search("ProhibitDotFilesWrite\s+yes",line,re.I):
			args = args + " -x "

		if re.search("ProhibitDotFilesRead\s+yes",line,re.I):
			args = args + " -X "

		if re.search("AllowDotFiles\s+yes",line,re.I):
			args = args + " -z "			

		if re.search("AutoRename\s+yes",line,re.I):
			args = args + " -r "
                        
		if re.search("AnonymousCantUpload\s+yes",line,re.I):
			args = args + " -i "

		m = re.search("TrustedIP\s+(\S+)",line,re.I)
		if m !=None :
			args = args + " -V " +m.group(1)

		if re.search("LogPID\s+yes",line,re.I):
			args = args + " -1 "
                        
		m = re.search("AltLog\s+(\S+)",line,re.I)
		if m !=None :
			args = args + " -O " +m.group(1)

		if re.search("NoChmod\s+yes",line,re.I):
			args = args + " -R "

		if re.search("KeepAllFiles\s+yes",line,re.I):
			args = args + " -K "

		if re.search("CreateHomeDir\s+yes",line,re.I):
			args = args + " -j "

		m = re.search("PIDFile\s+(\S+)",line,re.I)
                if m !=None :    
			args = args + " -g " + m.group(1)
                        
	#print args
		
	os.system("/usr/local/sbin/pure-ftpd " + args)


